package org.tipple.mapDisplay;

import java.io.File;
import java.net.URL;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.mapsforge.android.maps.ArrayItemizedMarkerOverlay;
import org.mapsforge.android.maps.ArrayItemizedTextAudioOverlay;
import org.mapsforge.android.maps.CirclesOverlay;
import org.mapsforge.android.maps.GeoPoint;
import org.mapsforge.android.maps.MapView;
import org.mapsforge.android.maps.Overlay;
import org.mapsforge.android.maps.OverlayItem;
import org.mapsforge.android.maps.OverlayMarkerItem;
import org.mapsforge.android.maps.OverlayTextAudioItem;
import org.mapsforge.android.maps.RouteOverlayResetable;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import android.app.Activity;
import android.graphics.Color;
import android.graphics.DashPathEffect;
import android.graphics.Paint;
import android.graphics.drawable.Drawable;
import android.location.Location;
import android.location.LocationManager;
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnUtteranceCompletedListener;
import android.util.Log;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

public class copyOfLocationManager {
	protected LocationManager locationManager;
	protected static MapView mapview;
	protected ArrayList<tippleLocation> locations;
	protected Button retrieveLocationButton;
	protected double currentLongitude;
	protected double currentLatitude;
	protected double currentNodeId;
	protected String nodeId;
	protected Boolean bookSelected = true;// true for the first book, false for
											// the second book
	// global value for book url
	public static String hamiltonGardenURL = "HASH4e454a5d938158a2a3fcde";// HASH4e454a5d938158a2a3fcde
	public static String stationOfCrossURL = "HASH0158acd736565602cd1f1b1b";// HASH0158acd736565602cd1f1b1b

	Activity activity_;
	AudioPlayerView audio_player_view_;
	TextToSpeech tts_;
	TextView textview;
	protected tippleActivity.bookModeEnum current_book_mode_;

	public static CirclesOverlay circlesOverlay = null;
	// public static ArrayItemizedTextAudioOverlay itemizedMarkerOverlay;
	public static ArrayItemizedMarkerOverlay itemizedMarkerOverlay;
	public static ArrayList<OverlayItem> itemizedMarkerOverlayArrayList;
	public static ArrayList<GeoPoint> circlesOverlayGeoPoints;
	public static ArrayList<Integer> circlesOverlayRadii;

	public static RouteOverlayResetable routeOverlay = null;
	public static RouteOverlayResetable routeOverlay2 = null;
	public static ArrayItemizedTextAudioOverlay routeMarkerOverlay;
	public static GeoPoint[] routeOverlayArray;// hold first book overlay data
	public static ArrayList<String> nodeIDArray;
	public static GeoPoint[] routeOverlayArray2;// hold second book overlay data
	public static int lengthOfFirstBook = 0;
	public static int lengthOfSecondBook = 0;

	// paint color for route
	Paint fillPaint, fillPaint2, outlinePaint, outlinePaint2;

	public static ArrayList<OverlayItem> routeMarkerOverlayArrayList;
	public static HashMap<Integer, OverlayMarkerItem> highlight_marker_hash_;
	public static String prevVisitedFilename;
	Drawable defaultMarker;// declare as global variable

	ArrayList<tippleLocation> preLocations = null;// book hamilton Garden
	ArrayList<tippleLocation> temLocations = null;// seocnd station Of Cross

	copyOfLocationManager(Activity activity, MapView mapview,
			TextView textview, LocationManager manager,
			AudioPlayerView audio_player_view, TextToSpeech tts) {
		activity_ = activity;
		audio_player_view_ = audio_player_view;
		tts_ = tts;
		this.locationManager = manager;
		this.mapview = mapview;
		this.textview = textview;

		// initailize these arraylist value

		Paint circleFillPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		circleFillPaint.setStyle(Paint.Style.FILL);
		circleFillPaint.setColor(Color.BLUE);
		circleFillPaint.setAlpha(64);

		Paint circleOutlinePaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		circleOutlinePaint.setStyle(Paint.Style.STROKE);
		// circleOutlinePaint.setStyle(Paint.Style.FILL);
		circleOutlinePaint.setColor(Color.BLUE);
		circleOutlinePaint.setAlpha(64);// initially 128
		circleOutlinePaint.setStrokeWidth(1);
		circlesOverlay = new CirclesOverlay(circleFillPaint, circleOutlinePaint);
		circlesOverlayGeoPoints = new ArrayList<GeoPoint>();
		circlesOverlayRadii = new ArrayList<Integer>();
		defaultMarker = activity_.getResources().getDrawable(R.drawable.marker);
		itemizedMarkerOverlay = new ArrayItemizedMarkerOverlay(defaultMarker,
				activity_);
		// itemizedMarkerOverlay = new ArrayItemizedTextAudioOverlay(
		// defaultMarker, activity_);
		itemizedMarkerOverlayArrayList = new ArrayList<OverlayItem>();
		highlight_marker_hash_ = new HashMap<Integer, OverlayMarkerItem>();
		fillPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		// deal with routeoverlay
		fillPaint.setStyle(Paint.Style.STROKE);
		fillPaint.setColor(Color.BLUE);
		fillPaint.setAlpha(160);
		fillPaint.setStrokeWidth(7);
		fillPaint.setStrokeCap(Paint.Cap.BUTT);
		fillPaint.setStrokeJoin(Paint.Join.ROUND);
		fillPaint.setPathEffect(new DashPathEffect(new float[] { 20, 20 }, 0));

		outlinePaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		outlinePaint.setStyle(Paint.Style.STROKE);
		outlinePaint.setColor(Color.BLUE);
		outlinePaint.setAlpha(96);
		outlinePaint.setStrokeWidth(7);
		outlinePaint.setStrokeCap(Paint.Cap.BUTT);
		outlinePaint.setStrokeJoin(Paint.Join.ROUND);
		fillPaint2 = new Paint(Paint.ANTI_ALIAS_FLAG);
		// deal with routeoverlay
		fillPaint2.setStyle(Paint.Style.STROKE);
		fillPaint2.setColor(Color.RED);
		fillPaint2.setAlpha(160);
		fillPaint2.setStrokeWidth(7);
		fillPaint2.setStrokeCap(Paint.Cap.BUTT);
		fillPaint2.setStrokeJoin(Paint.Join.ROUND);
		fillPaint2.setPathEffect(new DashPathEffect(new float[] { 20, 20 }, 0));

		outlinePaint2 = new Paint(Paint.ANTI_ALIAS_FLAG);
		outlinePaint2.setStyle(Paint.Style.STROKE);
		outlinePaint2.setColor(Color.BLUE);
		outlinePaint2.setAlpha(96);
		outlinePaint2.setStrokeWidth(7);
		outlinePaint2.setStrokeCap(Paint.Cap.BUTT);
		outlinePaint2.setStrokeJoin(Paint.Join.ROUND);

		routeOverlay = new RouteOverlayResetable(fillPaint, outlinePaint);
		routeOverlay2 = new RouteOverlayResetable(fillPaint2, outlinePaint2);

	}

	Location thislocation;// lastknown location should be global

	protected String getCurrentLocation() {
		String myCurrentLongitude = null;
		thislocation = locationListener.lastKnownLocation;
		if (thislocation != null) {

			currentLongitude = thislocation.getLongitude();
			currentLatitude = thislocation.getLatitude();

			// Toast.makeText(Tipple.this, message, Toast.LENGTH_LONG).show();
			String[] result = (String.valueOf(currentLatitude)).split("\\.");
			// myCurrentLongitude = result[1].substring(0, 4);
			myCurrentLongitude = result[0].substring(1, 3);// image start
			// from
			// -,
			DecimalFormat trunPlaces = new DecimalFormat("0.0000");
			String text_mess = "(Long,Lat): ("
					+ trunPlaces.format(currentLongitude) + ","
					+ trunPlaces.format(currentLatitude) + ")";
			textview.setText(text_mess);
			// String myCurrentLongitude = "-37.80608675";

		} else {
			Toast.makeText(activity_, "failed to get GPS", Toast.LENGTH_LONG)
					.show();

		}
		return myCurrentLongitude;
	}

	protected void createLogRouteLocationsOverlay(MapView mapView,
			ArrayList<tippleLocation> locations) {
		Paint fillPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		fillPaint.setStyle(Paint.Style.STROKE);
		fillPaint.setColor(Color.BLUE);
		fillPaint.setAlpha(160);
		fillPaint.setStrokeWidth(7);
		fillPaint.setStrokeCap(Paint.Cap.BUTT);
		fillPaint.setStrokeJoin(Paint.Join.ROUND);
		fillPaint.setPathEffect(new DashPathEffect(new float[] { 20, 20 }, 0));

		Paint outlinePaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		outlinePaint.setStyle(Paint.Style.STROKE);
		outlinePaint.setColor(Color.BLUE);
		outlinePaint.setAlpha(96);
		outlinePaint.setStrokeWidth(7);
		outlinePaint.setStrokeCap(Paint.Cap.BUTT);
		outlinePaint.setStrokeJoin(Paint.Join.ROUND);

		Drawable defaultMarker = activity_.getResources().getDrawable(
				R.drawable.routemarker);

		if (routeOverlay == null) {
			routeOverlay = new RouteOverlayResetable(fillPaint, outlinePaint);
			routeMarkerOverlay = new ArrayItemizedTextAudioOverlay(
					defaultMarker, activity_, tts_);
			routeMarkerOverlayArrayList = new ArrayList<OverlayItem>();

		}
		// This one needs to be done again, incase it is of a different size
		routeOverlayArray = new GeoPoint[locations.size()];

		for (int i = 0; i < locations.size(); i++) {
			tippleLocation location = locations.get(i);
			double latitude = location.getlatitude();
			double longitude = location.getlongitude();
			String title = location.getTitle();
			String text = location.getContent();
			String tts_text = location.getTTSText();
			GeoPoint geoPoint = new GeoPoint(latitude, longitude);

			routeOverlayArray[i] = geoPoint;

			// if (title.startsWith("Manual")) {
			// ItemizedOverlay => display marker with text for info pop-up
			// window
			OverlayTextAudioItem overlayItem = new OverlayTextAudioItem(
					geoPoint, title, text, tts_text);

			// routeMarkerOverlay.addOverlay(overlayItem);
			routeMarkerOverlayArrayList.add(overlayItem);
			// }
		}

		// routeOverlay.setRouteData(routeOverlayArray);

		// Only add in if not already present
		List<Overlay> overlays = mapView.getOverlays();
		if (!overlays.contains(routeOverlay)) {
			overlays.add(routeOverlay);
		}
		if (!overlays.contains(routeMarkerOverlay)) {
			overlays.add(routeMarkerOverlay);
		}
	}

	protected void addLogRouteLocations(MapView mapView) {
		for (int i = 0; i < routeMarkerOverlayArrayList.size(); i++) {

			OverlayItem overlay_item = routeMarkerOverlayArrayList.get(i);
			routeMarkerOverlay.addOverlay(overlay_item);
		}
		routeOverlay.setRouteData(routeOverlayArray);

		mapView.invalidate();

	}

	protected void removeLogRouteLocations(MapView mapView) {

		for (int i = 0; i < routeMarkerOverlayArrayList.size(); i++) {

			OverlayItem overlay_item = routeMarkerOverlayArrayList.get(i);
			routeMarkerOverlay.removeOverlay(overlay_item);

		}

		routeOverlay.reset();

		mapView.invalidate();
	}

	protected void createTourLocationsOverlay(MapView mapView,
			ArrayList<tippleLocation> locations) {
		System.out.println("createTourLocaitonOverlay"
				+ String.valueOf(lengthOfFirstBook) + "size"
				+ String.valueOf(lengthOfSecondBook)
				+ "check two locations size");
		// This one needs to be done again, incase it is of a different size
		routeOverlayArray = new GeoPoint[lengthOfFirstBook];// changed it
															// later
															// on
		routeOverlayArray2 = new GeoPoint[lengthOfSecondBook];// supposed to
		// store second
		// book
		// with two chapters
		System.out
				.println("createTourLocaitonOverlay" + routeOverlayArray.length
						+ "size" + routeOverlayArray2.length);
		// nodeIDArray = new ArrayList<String>();
		int numOfFirstRoute = 0;
		int numOfSecondRoute = 0;
		for (int i = 0; i < locations.size(); i++) {
			tippleLocation location = locations.get(i);
			double latitude = location.getlatitude();
			double longitude = location.getlongitude();
			int radius = (int) Math.round(1000.0 * location.getradius());
			String title = location.getTitle();
			String text = location.getContent();
			String tts_text = location.getTTSText();
			String chapter = location.getChapter();
			String nodeID = location.getNodeID();
			String[] curbookId = nodeID.split("\\.");
			GeoPoint geoPoint = new GeoPoint(latitude, longitude);
			// System.out.println("createTourLocation" +
			// String.valueOf(latitude));
			// add geo to routOverlayArray

			// CirclesOverlay => Highlight location with a circle showing
			// catchment radius
			// circlesOverlay.addCircleData(geoPoint, radius);
			circlesOverlayGeoPoints.add(geoPoint);
			circlesOverlayRadii.add(radius);

			// ItemizedOverlay => display marker with text for info pop-up
			// window
			OverlayTextAudioItem overlayItem = new OverlayTextAudioItem(
					geoPoint, title, text, tts_text, chapter, nodeID);

			// itemizedMarkerOverlay.addOverlay(overlayItem);
			itemizedMarkerOverlayArrayList.add(overlayItem);
			// if (tippleActivity.showUserTrail)

			if (curbookId[0].equalsIgnoreCase(stationOfCrossURL)) {
				routeOverlayArray2[numOfSecondRoute] = geoPoint;
				numOfSecondRoute++;
			}

			// else if (curbookId[0].equalsIgnoreCase(hamiltonGardenURL)) {
			// routeOverlayArray[i] = geoPoint;
			// }

			else {
				routeOverlayArray[numOfFirstRoute] = geoPoint;
				numOfFirstRoute++;
			}
			// nodeIDArray.add(nodeID);
		}

		// Only add in if not already present
		List<Overlay> overlays = mapView.getOverlays();

		if (!overlays.contains(itemizedMarkerOverlay)) {
			overlays.add(itemizedMarkerOverlay);
		}
		if (!overlays.contains(circlesOverlay)) {
			overlays.add(circlesOverlay);
		}
		// if (tippleActivity.showUserTrail) {
		if (!overlays.contains(routeOverlay)) {
			overlays.add(routeOverlay);
		}
		if (!overlays.contains(routeOverlay2)) {
			overlays.add(routeOverlay2);
		}
		// }

	}

	protected void addTourLocations(MapView mapView, Boolean showTrail) {
		for (int i = 0; i < itemizedMarkerOverlayArrayList.size(); i++) {

			OverlayTextAudioItem here_marker_item = (OverlayTextAudioItem) itemizedMarkerOverlayArrayList
					.get(i);

			GeoPoint dm_geopoint = here_marker_item.getPoint();
			String chapter = here_marker_item.getChapter();
			String[] bookId = (here_marker_item.getNodeID()).split("\\.");
			Drawable marker;
			OverlayMarkerItem highlight_marker_item;
			if (bookId[0].equalsIgnoreCase(stationOfCrossURL)) {//
				// Garden
				// Design:HASH012992fff824b01e87d30f32
				// hamilton
				// Garden;
				// HASHe280873a5c76118bd7e1a7
				marker = activity_.getResources().getDrawable(
						R.drawable.markergreen);// greeen color
				highlight_marker_item = new OverlayMarkerItem(dm_geopoint,
						chapter);
				highlight_marker_item.setMarker((marker));
				routeOverlay.setPaint(fillPaint2, outlinePaint2);

			} else {
				highlight_marker_item = new OverlayMarkerItem(dm_geopoint,
						chapter);
				itemizedMarkerOverlay.setMarker(defaultMarker);// red color
				routeOverlay2.setPaint(fillPaint, outlinePaint);
			}

			highlight_marker_hash_.put(i, highlight_marker_item);
			itemizedMarkerOverlay.addOverlay(highlight_marker_item);

			GeoPoint geo_point = circlesOverlayGeoPoints.get(i);
			int radius = circlesOverlayRadii.get(i);
			circlesOverlay.addCircleData(geo_point, radius);
		}
		// next check the routeOverlay nodeID, then call SetPaint method to
		// change the route color
		if (showTrail) {
			// if (routeOverlayArray.length > 0)
			if (lengthOfFirstBook > 0)
				routeOverlay.setRouteData(routeOverlayArray);
			// if (routeOverlayArray2.length > 0)
			if (lengthOfSecondBook > 0)
				routeOverlay2.setRouteData(routeOverlayArray2);
		}

		mapView.invalidate();
	}

	protected void removeTourLocations(MapView mapView) {
		if (itemizedMarkerOverlayArrayList.size() > 0) {
			for (int i = 0; i < itemizedMarkerOverlayArrayList.size(); i++) {

				OverlayMarkerItem highlight_marker_item = highlight_marker_hash_
						.remove(i);
				itemizedMarkerOverlay.removeOverlay(highlight_marker_item);
			}
			highlight_marker_hash_.clear();
			circlesOverlay.reset();
			// remove routeOverlay item from the map
			if ((routeOverlay != null) || (routeOverlay2 != null)) {// no matter
																	// boolean
																	// showUserTrail,
				// always need to reset to initial
				// value.
				routeOverlay.reset();
				routeOverlay2.reset();
			}
			mapView.invalidate();
		} else {
			System.out.println("removeTourLocation "
					+ itemizedMarkerOverlayArrayList.size());
		}

	}

	private String queryString(Boolean bookOption) {

		String urlLocation = "";

		this.bookSelected = bookOption;
		// bookeSeleted for the bookA: hamilton Garden
		if (bookSelected) {
			urlLocation = "http://130.217.244.51:8383/greenstone3/dev?a=d&ed=1&book=off"
					+ "&c=hamilton&d=";// HASH4e454a5d938158a2a3fcde
			urlLocation += hamiltonGardenURL;
			urlLocation += "&dt=hierarchy&p.a=b&p.sa=&p.s=ClassifierBrowse&o=xml";
		}
		// book 2
		else
		// bookSelected for the book B : Garden Design
		{
			urlLocation = "http://130.217.244.51:8383/greenstone3/dev?a=d&ed=1&book=off"
					+ "&c=hamilton&d=";// HASH012992fff824b01e87d30f32
			urlLocation += stationOfCrossURL;
			urlLocation += "&dt=hierarchy&p.a=b&p.sa=&p.s=ClassifierBrowse&o=xml";
		}
		// book 1 and book 2

		return urlLocation;
	}

	/*
	 * now only pass the longitude location to connect to DL, need to pass
	 * longitude and latitude later on?
	 */
	protected ArrayList<HashMap<String, String>> parseXMLToHashMapArrayList(
			Boolean bookOption) {

		ArrayList<HashMap<String, String>> hashmap_list = null;
		String urlLocation;
		try {
			urlLocation = queryString(bookOption);
			URL url = new URL(urlLocation);
			SAXParserFactory spf = SAXParserFactory.newInstance();
			SAXParser sp = spf.newSAXParser();

			XMLReader xr = sp.getXMLReader();

			xmlHandler myExampleHandler = new xmlHandler("documentNode");

			xr.setContentHandler(myExampleHandler);

			xr.parse(new InputSource(url.openStream()));

			hashmap_list = myExampleHandler.getHashmapList();

		} catch (Exception e) {
			// Log.e(MY_DEBUG_TAG, "Failed to get DL data", e);
			System.out.println("can't connect to the DL server");
		}
		return hashmap_list;

	}

	public ArrayList<tippleLocation> loadTour(Boolean bookOption) {

		ArrayList<HashMap<String, String>> location_hashmap_list = parseXMLToHashMapArrayList(bookOption);

		if (location_hashmap_list != null) {
			Log.d("TippleActivity::loadTour()", "XML Tour File Parsed");
		}

		ArrayList<tippleLocation> locations = new ArrayList<tippleLocation>();
		System.out.println(" LoadTour size of hashmaplist "
				+ location_hashmap_list.size());
		for (int i = 0; i < location_hashmap_list.size() - 1; i++) {
			HashMap<String, String> location_hashmap = location_hashmap_list
					.get(i);
			tippleLocation location = new tippleLocation(location_hashmap);
			locations.add(location);

		}
		location_hashmap_list.clear();
		location_hashmap_list = null;
		if (bookOption)
			lengthOfFirstBook = locations.size();
		else
			lengthOfSecondBook = locations.size();
		return locations;
	}

	public ArrayList<tippleLocation> loadTourDescription() {
		preLocations = loadTour(true);// load book A
		lengthOfFirstBook = preLocations.size();
		temLocations = new ArrayList<tippleLocation>();
		temLocations = loadTour(false);// load book B
		lengthOfSecondBook = temLocations.size();

		for (int i = 0; i < preLocations.size(); i++) {
			tippleLocation preLocation = preLocations.get(i);
			temLocations.add(preLocation);
		}
		// preLocations.clear();
		// preLocations = null;
		// return temLocations;
		return temLocations;

	}

	/*
	 * clear route data, allows route reset data based on the showTrail option.
	 */
	public void resetRouteOverlay() {
		// if (routeOverlayArray != null)
		// routeOverlayArray = null;
		// if (routeOverlayArray2 != null)
		// routeOverlayArray = null;
		if (routeOverlay != null) {// no matter boolean showUserTrail,
			// always need to reset to initial
			// value.
			routeOverlay.reset();
		}
		if (routeOverlay2 != null)
			routeOverlay2.reset();
		if (routeMarkerOverlay != null) {
			// routeMarkerOverlay.stop();
			routeMarkerOverlay.clear();
		}

	}

	/*
	 * clear route data, circle data and locations data
	 */
	public void resetOverlayThreads() {
		resetRouteOverlay();// reset route data
		if (circlesOverlayGeoPoints != null) {
			circlesOverlayGeoPoints.clear();
			// circlesOverlayGeoPoints = null;
		}
		if (circlesOverlayRadii != null) {
			circlesOverlayRadii.clear();
			// circlesOverlayRadii = null;
		}
		if (circlesOverlay != null) {
			// circlesOverlay.stop();
			circlesOverlay.reset();

			// circlesOverlay = null;
		}

		if (itemizedMarkerOverlay != null) {
			itemizedMarkerOverlay.clear();

			// itemizedMarkerOverlay = null;
		}
		if (highlight_marker_hash_ != null)

		{
			highlight_marker_hash_.clear();
			// highlight_marker_hash_ = null;
		}

		if (itemizedMarkerOverlayArrayList != null) {
			itemizedMarkerOverlayArrayList.clear();
			// itemizedMarkerOverlayArrayList = null;
		}
		lengthOfFirstBook = 0;
		lengthOfSecondBook = 0;
		if (routeOverlayArray != null)
			routeOverlayArray = null;
		if (routeOverlayArray2 != null)
			routeOverlayArray = null;
		System.gc();

	}

	public static void stopOverlayThreads() {
		if (circlesOverlay != null) {
			// circlesOverlay.stop();
			circlesOverlay = null;
		}

		if (itemizedMarkerOverlay != null) {
			// itemizedMarkerOverlay.stop();
			itemizedMarkerOverlay = null;
		}

		if (routeOverlay != null) {
			// routeOverlay.stop();
			routeOverlay = null;
		}
		if (routeOverlay2 != null) {
			routeOverlay2 = null;
		}
		if (routeMarkerOverlay != null) {
			// routeMarkerOverlay.stop();
			routeMarkerOverlay = null;
		}
	}

	protected String SyncSynthesizeToFile(String text, String id,
			String root_utterance) {
		// String audio_dir = tippleActivity.audioDirectory;
		String audio_dir = "/sdcard/";
		File tts_file = new File(audio_dir, id + "-" + root_utterance
				+ "-TTS.wav");
		String tts_filename = tts_file.getAbsolutePath();

		if (tts_file.exists()) {
			// already synthesized this
			return tts_filename;
		}

		// Rendering the supplied text of the id+utterance derived WAV file
		HashMap<String, String> hashRender = new HashMap<String, String>();
		hashRender.put(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, text);

		String UTTERANCE = root_utterance + "-utterance";

		hashRender.put(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, UTTERANCE);
		UtteranceWaitListener listener = new UtteranceWaitListener(UTTERANCE);
		tts_.setOnUtteranceCompletedListener(listener);

		tts_.synthesizeToFile(text, hashRender, tts_filename);

		try {
			listener.waitForComplete();
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}

		return tts_filename;
	}

	boolean genPrevVisited = true;

	public boolean textToSpeechToLocation(tippleLocation curtip_location,
			boolean visited_previously) {
		if (genPrevVisited) {
			prevVisitedFilename = SyncSynthesizeToFile("Previously visited.",
					"Previously-visited", "cue");
			System.err
					.println("** Prev visisted file = " + prevVisitedFilename);
			genPrevVisited = false;
		}
		// get updated location and talk to DL, update locations content data
		// tippleLocation tip_location = loadLocationContent(curtip_location);
		String title = curtip_location.getTitle();
		String text = curtip_location.getContent();
		String id = curtip_location.getID();

		String title_filename = SyncSynthesizeToFile(title, id, "title");
		String text_filename = SyncSynthesizeToFile(text, id, "text");

		if ((title_filename != null) && (text_filename != null)) {
			String audio_dir = tippleActivity.audioDirectory;
			File ding_file = new File(audio_dir, "DingExtended.wav");
			String ding_filename = ding_file.getAbsolutePath();
			//
			if (audio_player_view_.addAudio(id)) {
				// tippleActivity.log.optMessage("Queue Audio", title);
				audio_player_view_.queueAudio(title_filename, id, title,
						visited_previously);
				audio_player_view_.queueAudio(text_filename, id, text);
				audio_player_view_
						.queueAudio(ding_filename, id, "[Audio Bing]");

				audio_player_view_.updateTextViewIfHeadIsNewLocation();
				System.out
						.println("the size of audio player view queue should be at least 1"
								+ audio_player_view_.audioPlayerQueue_.size());
			}
		}
		System.out.println("the size "
				+ audio_player_view_.audioPlayerQueue_.size());
		return true;
	}

	private static class UtteranceWaitListener implements
			OnUtteranceCompletedListener {
		private boolean mIsComplete = false;
		private final String mExpectedUtterance;

		public UtteranceWaitListener(String expectedUtteranceId) {
			mExpectedUtterance = expectedUtteranceId;
		}

		public void onUtteranceCompleted(String utteranceId) {
			if (mExpectedUtterance.equals(utteranceId)) {
				synchronized (this) {
					mIsComplete = true;
					notify();
				}
			}
		}

		public boolean waitForComplete() throws InterruptedException {
			if (mIsComplete) {
				return true;
			}
			//
			synchronized (this) {
				int TTS_SPEECH_MAX_WAIT_TIME = 5 * 1000;
				wait(TTS_SPEECH_MAX_WAIT_TIME);
				return mIsComplete;
			}
		}

	}

}
